// "168_PWM.c" from Sparkfun "i-Racer" (http://www.sparkfun.com/products/11162)

/*
    referring to the schematic, "motor1" is the rear (drive) motor,     which is on OC1
                                "motor2" is the front (steering) motor, which is on OC0

    now in this software, "motorL" is OC1 => drive motor
                          "motorR" is OC0 => steering motor
*/

#include "168_PWM.h"

void delay_pwm(uchar time)
{
    uchar i,k,j;

    for(k=0;k<time;k++)
    {
        for(j=0;j<8;j++)
        {
            for(i=0;i<248;i++);
        }
    }
}

void PWM_RST(void)
{
    DDRB|=(1<<BIT1);
    DDRB|=(1<<BIT2);
    DDRD|=(1<<BIT5);
    DDRD|=(1<<BIT6);

    TCCR0A=0xf1;
    TCCR0B=0x00;

    TCNT0=0X0000;
    OCR0A=0X00EF;
    OCR0B=0X00EF;

    TIFR0 =0xff;
    TIMSK0=0X00;

    TCCR1A=0xf1;
    TCCR1B=0x00;

    TCNT1=0X0000;
    OCR1A=0X00EF;
    OCR1B=0X00EF;

    TIFR1 =0xff;
    TIMSK1=0X00;
}

void PWM_EN(uchar PWM_ON)
{
    if(PWM_ON==0)
    {
        TCCR0B=0x00;
        TCNT0=0X0000;
        OCR0A=0X00FF;
        OCR0B=0X00FF;


        TCCR1B=0x00;
        TCNT1=0X0000;
        OCR1A=0X00FF;
        OCR1B=0X00FF;

        return;
    }
    else
    {
        TCNT0=0X0000;
        OCR0A=0X00FF;
        OCR0B=0X00FF;
        TCCR0B=0x01;

        TCNT1=0X0000;
        OCR1A=0X00FF;
        OCR1B=0X00FF;
        TCCR1B=0x01;
        return;
    }
}

void motorR_reg(uchar DIR,uchar Empty) // steering motor
{
    if(DIR==0)
    {
        OCR0B=0Xff;
        delay_pwm(2);
        OCR0A=Empty;
    }
    else
    {
        OCR0A=0Xff;
        delay_pwm(2);
        OCR0B=Empty;
    }
}

void motorL_reg(uchar DIR,uchar Empty) // drive motor
{
    if(DIR==0)
    {
        OCR1B=0Xff;
        delay_pwm(5);
        OCR1A=Empty;
    }
    else
    {
        OCR1A=0Xff;
        delay_pwm(5);
        OCR1B=Empty;
    }
}


